require 'json'

name = ARGV[0]
w = ARGV[1].to_i
h = ARGV[2].to_i
n = ARGV[3].to_i
c = ARGV[4].to_i
holes = Array.new(w * h, false)
c.times do |i|
  holes[i] = true
end
holes.shuffle!

vs = []
ids = Array.new(w) { Array.new(h, 0) }
id = 0
h.times do |y|
  w.times do |x|
    unless holes[y*w+x]
      vs << {
        "x" => x + 0.5,
        "y" => y + 0.5,
      }
      ids[x][y] = id
      id += 1
    end
  end
end

es = []
dirs = [ [1,  0], [-1,  1], [0,  1], [1,  1] ]
h.times do |y|
  w.times do |x|
    next if holes[y*w+x]
    dirs.each do |dir|
      dx, dy = dir
      cx, cy = x + dx, y + dy
      while cx >= 0 && cy >= 0 && cx < w && cy < h
        unless holes[cy*w+cx]
          es << {
            "from": ids[x][y],
            "to": ids[cx][cy]
          }
          break
        end
        cx += dx
        cy += dy
      end
    end
  end
end

puts JSON.pretty_generate({
  "name" => name,
  "size" => {
    "width" => w,
    "height" => h,
  },
  "vertices" => vs,
  "edges" => es,
  "random_mines" => {
    "mines_count": n,
  },
  "style" => {
    "vertex" => {
      "shape" => "rectangle",
      "width" => (1.0 + [w, h].max / 900.0).round(5),
      "height" => (1.0 + [w, h].max / 900.0).round(5),
    },
  },
})

