require 'json'

name = ARGV[0]
w = ARGV[1].to_i
h = ARGV[2].to_i
mines = ARGV[3].to_i

vs = []
m = [w, h].max
h.times do |y|
  w.times do |x|
    vs << {
      "x" => x + 0.5,
      "y" => y + 0.5,
    }
  end
end

es = []
dirs = [ [-1, -1], [0, -1], [1, -1], [-1, 0], [1, 0], [-1, 1], [0, 1], [1, 1] ]
h.times do |y|
  w.times do |x|
    i = y * w + x;
    dirs.each do |dir|
      x2 = (x + w + dir[0]) % w;
      y2 = (y + h + dir[1]) % h;
      j = y2 * w + x2
      es << { "from" => i, "to" => j } if i < j
    end
  end
end

puts JSON.pretty_generate({
  "name" => "ループ(#{name})",
  "size" => {
      "width" => w,
      "height" => h,
  },
  "vertices" => vs,
  "edges" => es,
  "random_mines" => {
    "mines_count" => mines,
  },
  "style" => {
    "vertex" => {
      "shape" => "rectangle",
      "width" => (1.0 + m / 900.0).round(5),
      "height" => (1.0 + m / 900.0).round(5),
    },
  },
})

